package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Fox
// Camp: Foxes

class Fox extends Civilian {
	def static order = 7;
	def static strings = Civilian.strings.attachBundle("roles/Fox.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	// Returns the proper number.
	def static getJustnumber(number) {
		if(number > 14) {
			return 1;
		} else {
			return 0;
		}
	}
	Fox(actor = null) {
		super(actor);
	}
	def getPriority() {
		return 65;
	}
	// If it returns true, the role count as a civilian.
	def isCivilian() {
		return false;
	}
	def getRoleName() {
		return strings.getString("fox");
	}
	// Goes to next phase.
	def update() {
		super.update();
		if(divined) {
			killed(State.cursed);
			divined = false;
		}
	}
	// When the actor is killed.
	def killed(state) {
		if(state == State.live) {
			noticeKilled(strings.getString("notice.revived", name));
		} else {
			if(state == State.bitten) {
				return;
			} else if(state == State.deathnote) {
				noticeKilled(strings.getString("notice.killed.deathnote." + (Math.floor(Math.random() * 4) as int), name));
			} else if(state != State.executed) {
				noticeKilled(strings.getString("notice.killed.normal", name));
			}
			JinroGame.addHistory(this);
		}
		this.state = state;
	}
	// Judges victory or defeat.
	// if the result is... 0: civilians win, 1: wolves win, 2: foxes win
	def judge(result) {
		return result == 2;
	}
}
