package scripts.roles;

import scripts.*;
import jinro.*;

// Role: Trader
// Camp: Civilians

class Trader extends Civilian {
	def static order = 15;
	def static strings = Civilian.strings.attachBundle("roles/Trader.properties");
	def static number = 0;		// All roles must define own "number" property.
	def static bite = false;	// All roles must define own "bite" property.
	def chose = false;
	def sent = false;
	def chosenItem;
	// Returns the proper number.
	def static getJustnumber(number) {
		return 0;
	}
	def getPriority() {
		return 28;
	}
	Trader(actor = null) {
		super(actor);
	}
	def getRoleName() {
		return strings.getString("trader");
	}
	// Calls when start argument/night time.
	def startPhase() {
		super.startPhase();
		switch(JinroGame.time) {
			case 0:
				break;
			case 1:
				if(!chose) {
					notice(strings.getString("notice.chooseItem"));
				}
				if(JinroGame.day >= 1 && !sent) {
					notice(strings.getString("notice.sendItem"));
				}
				break;
		}
	}
	// Returns the actor's command list
	def getCommands(actors) {
		def commands = super.getCommands(actors);
		if(!isLive()) {
			return commands;
		}
		// 0: daytime, 1: nighttime
		switch(JinroGame.time) {
			case 1:
				if(!chose) {
					["fortuneteller", "medium", "hunter"].each {
						commands << strings.getString("command.chooseItem") + "@" + strings.getString("poweritem." + it);
					}
				} else if(JinroGame.day >= 1 && !sent) {
					actors.findAll{ it.name != name && it.isLive() }.each {
						commands << strings.getString("command.sendItem") + "@" + it.name;
					}
				}
				break;
		}
		return commands;
	}
	def autoCommand(actors) {
		super.autoCommand(actors);
		switch(JinroGame.time) {
			case 0:
				break;
			case 1:
				if(!chose && Math.random() < 0.5) {
					def items = ["fortuneteller", "medium", "hunter"];
					receiveMessage(strings.getString("command.chooseItem"), strings.getString("poweritem." + items[Math.floor(Math.random() * items.size()) as int]));
				}
				if(chose && JinroGame.day >= 1) {
					if(!sent && Math.random() < 0.5) {
						def lives = actors.findAll { it.name != name && it.isLive() };
						def invokedDay = JinroGame.day;
						new Timer().runAfter((Math.floor(Math.random() * (JinroGame.getProperty("nighttime") - 1) * 60000) as int) + 15000, {
							if(JinroGame.day == invokedDay) {
								receiveMessage(strings.getString("command.sendItem"), lives[Math.floor(Math.random() * lives.size()) as int]);
							}
						});
					}
				}
				break;
		}
	}
	def receiveMessage(type, target) {
		super.receiveMessage(type, target);
		switch(JinroGame.time) {
			case 0:
				break;
			case 1:
				if(!chose) {
					if(type == strings.getString("command.chooseItem")) {
						if(!["fortuneteller", "medium", "hunter"].findAll({ strings.getString("poweritem." + it) == target }).isEmpty()) {
							chosenItem = target;
							notice(strings.getString("notice.chooseItem.target", target));
							chose = true;
						}
					}
				} else if(!sent) {
					if(type == strings.getString("command.sendItem")) {
						if(target.name != name && target.isLive()) {
							target.powerItem = chosenItem;
							notice(strings.getString("notice.sendItem.target", target.name));
							target.notice(strings.getString("notice.gotItem", chosenItem));
							target.noticePowerItemCommand();
							sent = true;
						}
					}
				}
				break;
		}

	}
}
